--- old/usr/src/tools/smatch/Makefile	Tue Jan  7 08:01:51 2020
+++ new/usr/src/tools/smatch/Makefile	Tue Jan  7 08:01:51 2020
@@ -8,7 +8,7 @@
 # source.  A copy of the CDDL is also available via the Internet at
 # http://www.illumos.org/license/CDDL.
 #
-# Copyright 2019 Joyent, Inc.
+# Copyright 2020 Joyent, Inc.
 #
 
 #
@@ -20,7 +20,7 @@
 #
 
 PROG = smatch
-SPARSE_VERSION = 0.6.1-rc1-il-2
+SPARSE_VERSION = 0.6.1-rc1-il-3
 
 include ../Makefile.tools
 
@@ -31,7 +31,8 @@
 i386_SMATCHFLAGS = -msave-args
 sparc_SMATCHFLAGS =
 
-CFLAGS = -O -m64 $($(MACH)_SMATCHFLAGS) -D__sun -Wall -Wno-unknown-pragmas -std=gnu99 -nodefaultlibs
+CFLAGS = -O -m64 -std=gnu99 -nodefaultlibs -D__sun $($(MACH)_SMATCHFLAGS)
+CFLAGS += -Wall -Wno-unknown-pragmas -Wno-psabi
 
 SMATCHDATADIR = $(ROOTONBLDSHARE)/smatch
 
@@ -176,6 +177,7 @@
 SMATCH_OBJS += smatch_unknown_value.o
 SMATCH_OBJS += smatch_untracked_param.o
 SMATCH_OBJS += smatch_var_sym.o
+SMATCH_OBJS += smatch_parsed_conditions.o
 
 SMATCH_CHECK_OBJS:sh=ls src/check_*.c | sed -e 's+\.c+.o+;s+src/++;'
 
--- old/usr/src/tools/smatch/src/Makefile	Tue Jan  7 08:01:51 2020
+++ new/usr/src/tools/smatch/src/Makefile	Tue Jan  7 08:01:51 2020
@@ -1,4 +1,4 @@
-VERSION=0.6.1-rc1-il-2
+VERSION=0.6.1-rc1-il-3
 
 ########################################################################
 # The following variables can be overwritten from the command line
@@ -95,7 +95,7 @@
 # common flags/options/...
 
 cflags = -fno-strict-aliasing
-cflags += -Wall -Wwrite-strings -Wno-switch
+cflags += -Wall -Wwrite-strings -Wno-switch -Wno-psabi
 
 GCC_BASE := $(shell $(CC) --print-file-name=)
 cflags += -DGCC_BASE=\"$(GCC_BASE)\"
@@ -254,6 +254,7 @@
 SMATCH_OBJS += smatch_param_to_mtag_data.o
 SMATCH_OBJS += smatch_param_used.o
 SMATCH_OBJS += smatch_parse_call_math.o
+SMATCH_OBJS += smatch_parsed_conditions.o
 SMATCH_OBJS += smatch_passes_array_size.o
 SMATCH_OBJS += smatch_project.o
 SMATCH_OBJS += smatch_ranges.o
--- old/usr/src/tools/smatch/src/check_debug.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_debug.c	Tue Jan  7 08:01:52 2020
@@ -15,6 +15,8 @@
  * along with this program; if not, see http://www.gnu.org/copyleft/gpl.txt
  */
 
+#include <string.h>
+
 #include "smatch.h"
 #include "smatch_slist.h"
 #include "smatch_extra.h"
@@ -86,7 +88,7 @@
 	}
 
 	FOR_EACH_SM(__get_cur_stree(), sm) {
-		if (strcmp(check_name(sm->owner), check_arg->string->data) != 0)
+		if (!strstr(check_name(sm->owner), check_arg->string->data))
 			continue;
 		sm_msg("%s", show_sm(sm));
 		found = 1;
@@ -514,6 +516,16 @@
 	local_debug = 0;
 }
 
+static void match_debug_db_on(const char *fn, struct expression *expr, void *info)
+{
+	debug_db = 1;
+}
+
+static void match_debug_db_off(const char *fn, struct expression *expr, void *info)
+{
+	debug_db = 0;
+}
+
 static void match_about(const char *fn, struct expression *expr, void *info)
 {
 	struct expression *arg;
@@ -773,6 +785,8 @@
 	add_function_hook("__smatch_debug_off", &match_debug_off, NULL);
 	add_function_hook("__smatch_local_debug_on", &match_local_debug_on, NULL);
 	add_function_hook("__smatch_local_debug_off", &match_local_debug_off, NULL);
+	add_function_hook("__smatch_debug_db_on", &match_debug_db_on, NULL);
+	add_function_hook("__smatch_debug_db_off", &match_debug_db_off, NULL);
 	add_function_hook("__smatch_intersection", &match_intersection, NULL);
 	add_function_hook("__smatch_type", &match_type, NULL);
 	add_implied_return_hook("__smatch_type_rl_helper", &match_type_rl_return, NULL);
--- old/usr/src/tools/smatch/src/check_debug.h	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_debug.h	Tue Jan  7 08:01:52 2020
@@ -46,6 +46,9 @@
 static inline void __smatch_local_debug_on(void){}
 static inline void __smatch_local_debug_off(void){}
 
+static inline void __smatch_debug_db_on(void){}
+static inline void __smatch_debug_db_off(void){}
+
 static inline void __smatch_debug_implied_on(void){}
 static inline void __smatch_debug_implied_off(void){}
 
--- old/usr/src/tools/smatch/src/check_frees_param.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_frees_param.c	Tue Jan  7 08:01:52 2020
@@ -29,7 +29,6 @@
 
 STATE(freed);
 STATE(ignore);
-STATE(param);
 
 static void set_ignore(struct sm_state *sm, struct expression *mod_expr)
 {
@@ -36,20 +35,6 @@
 	set_state(my_id, sm->name, sm->sym, &ignore);
 }
 
-static void match_function_def(struct symbol *sym)
-{
-	struct symbol *arg;
-	int i;
-
-	i = -1;
-	FOR_EACH_PTR(sym->ctype.base_type->arguments, arg) {
-		i++;
-		if (!arg->ident)
-			continue;
-		set_state(my_id, arg->ident->name, arg, &param);
-	} END_FOR_EACH_PTR(arg);
-}
-
 static void freed_variable(struct expression *expr)
 {
 	struct sm_state *sm;
@@ -111,8 +96,6 @@
 		return;
 	}
 
-	add_hook(&match_function_def, FUNC_DEF_HOOK);
-
 	add_function_hook("free", &match_free, INT_PTR(0));
 
 	select_return_implies_hook(PARAM_FREED, &set_param_freed);
--- old/usr/src/tools/smatch/src/check_list.h	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_list.h	Tue Jan  7 08:01:52 2020
@@ -25,6 +25,9 @@
 CK(register_param_compare_limit_links)
 CK(register_returns_early)
 
+CK(register_param_cleared)  /* param_set relies on param_cleared */
+CK(register_param_set)
+
 CK(register_smatch_ignore)
 CK(register_buf_size)
 CK(register_strlen)
@@ -31,10 +34,7 @@
 CK(register_strlen_equiv)
 CK(register_capped)
 CK(register_parse_call_math)
-CK(register_param_limit)
 CK(register_param_filter)
-CK(register_param_set)
-CK(register_param_cleared)
 CK(register_struct_assignment)
 CK(register_comparison)
 CK(register_comparison_links)
@@ -58,6 +58,7 @@
 CK(register_bits)
 CK(register_fn_arg_link)
 CK(register_parameter_names)
+CK(register_param_limit)
 CK(register_return_to_param)
 CK(register_return_to_param_links)
 CK(register_constraints)
@@ -207,6 +208,7 @@
 CK(register_scope)
 CK(register_stored_conditions)
 CK(register_stored_conditions_links)
+CK(register_parsed_conditions)
 CK(register_sval)
 CK(register_buf_size_late)
 CK(register_smatch_extra_late)
--- old/usr/src/tools/smatch/src/check_locking.c	Tue Jan  7 08:01:52 2020
+++ new/usr/src/tools/smatch/src/check_locking.c	Tue Jan  7 08:01:52 2020
@@ -1,5 +1,6 @@
 /*
  * Copyright (C) 2009 Dan Carpenter.
+ * Copyright (C) 2019 Oracle.
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -15,17 +16,7 @@
  * along with this program; if not, see http://www.gnu.org/copyleft/gpl.txt
  */
 
-/*
- * This test checks that locks are held the same across all returns.
- *
- * Of course, some functions are designed to only hold the locks on success.
- * Oh well... We can rewrite it later if we want.
- *
- * The list of wine locking functions came from an earlier script written
- * by Michael Stefaniuc.
- *
- */
-
+#include <ctype.h>
 #include "parse.h"
 #include "smatch.h"
 #include "smatch_extra.h"
@@ -33,25 +24,55 @@
 
 static int my_id;
 
-static int func_has_transition;
-
 STATE(locked);
+STATE(half_locked);
 STATE(start_state);
 STATE(unlocked);
 STATE(impossible);
+STATE(restore);
 
 enum action {
 	LOCK,
 	UNLOCK,
+	RESTORE,
 };
 
+enum lock_type {
+	spin_lock,
+	read_lock,
+	write_lock,
+	mutex,
+	bottom_half,
+	irq,
+	sem,
+	prepare_lock,
+	enable_lock,
+};
+
+const char *get_lock_name(enum lock_type type)
+{
+	static const char *names[] = {
+		[spin_lock] = "spin_lock",
+		[read_lock] = "read_lock",
+		[write_lock] = "write_lock",
+		[mutex] = "mutex",
+		[bottom_half] = "bottom_half",
+		[irq] = "irq",
+		[sem] = "sem",
+		[prepare_lock] = "prepare_lock",
+		[enable_lock] = "enable_lock",
+	};
+
+	return names[type];
+}
+
 enum return_type {
 	ret_any,
-	ret_non_zero,
 	ret_zero,
 	ret_one,
 	ret_negative,
 	ret_positive,
+	ret_valid_ptr,
 };
 
 #define RETURN_VAL -1
